<?php
// POS command: Do not modify
include_once 'PHPLibraries/GlobalFunctions.php';
include_once 'PHPLibraries/CartFunctions.php';
include_once 'PHPLibraries/DBFunctions.php';

{
	$TempAction = '';
	
	StartSession();
	$TempTongue = $_SESSION['Tongue'];
	
	if (array_key_exists('Action', $_GET))
		{
		$TempAction = $_GET['Action'];
		}
		
	switch ($TempAction)
	{
	case 'Add':
		$TempProductID = $_GET['ID'];
		
		// Verify if the product ID is in the valid Product IDs list
		$IsProductIDValid = DBIsProductIDValid($TempProductID);
		
		if ($IsProductIDValid)
		{
			$TempProduct = DBGetProductData($TempProductID, $TempTongue);
			
			AddProductToCart($TempProduct);
					
			ShowCart($TempTongue);
		}
		else
		{
			// The product ID is not valid
			
		}
		
		break;		
	
	case 'Remove':
		RemoveProductFromCart($_GET['ID']);
		ShowCart($TempTongue);
		break;
	
	case 'Modify':
		$TempProductID = $_GET['ID'];
		
		// Verify if the product ID is in the valid Product IDs list
		$IsProductIDValid = DBIsProductIDValid($TempProductID);
		
		if ($IsProductIDValid)
		{
			$TempProduct = DBGetProductData($TempProductID, $TempTongue);
	
			ModifyCartQuantity($TempProduct, $_POST);
	
			ShowCart($TempTongue);
			
		}
		else
		{
			// The product ID is not valid
			
		}

		break;
	
	case 'GetInformations':
		
		//$TempInformations = LoadFile('Templates/TTemplateCartPageCustomerInfosEdit.txt'.$TempTongue.'.txt');
		ShowCart($TempTongue, true, 'TTemplateCartPageCustomerInfosEdit');
		
		break;
	
	case 'ModifyData':
	
		$TempCodeMessage = '';
	
		if (!array_key_exists('ConfirmedLocation', $_GET))
		{
	
		// User infos
		$_SESSION['User.Name'] = $_POST['tName'];
		$_SESSION['User.Phone'] = $_POST['tPhone'];
		$_SESSION['User.Email'] = filter_var($_POST['tEmail'], FILTER_SANITIZE_EMAIL);
		$_SESSION['User.Notes'] = $_POST['tNotes'];
	
		// Location
		if (array_key_exists('oLocation', $_POST))
			{
			ModifyShippingLocation(substr($_POST['oLocation'],1));
			}

						
		// Coupon
		$TempCode = strtoupper($_POST['tCouponCode']);
		
		$TempCodeMessage = '';
		
		if ($TempCode <> '')
		{
			$TempData = LoadFileData('Data/Coupons.php',0,filesize('Data/Coupons.php')-1);
			$TempData = DBDecodeCouponsData($TempData);
		
			// Validate code
			$TempPassed = false;
		
			for ($x = 0; $x < count($TempData); $x++)
			{
				if ($TempData[$x]['Code'] == $TempCode)
				{
					$TempPassed = true;
					$_SESSION['User.CouponData'] = $TempData[$x];
				}
			}
		
			if ($TempPassed)
			{
				$_SESSION['User.CouponCode'] = $TempCode;
			}
			else
			{
				$_SESSION['User.CouponCode'] = '';		
				$TempCodeMessage = 'Code not found / Code non trouv';
			}
		}
		else
		{
			$_SESSION['User.CouponCode'] = '';		
			$_SESSION['User.CouponData'] = '';
		}

		// Verify name
		if($_SESSION['User.Name'] == "")
		{
			ShowCart($TempTongue, true, 'TTemplateCartPageCustomerInfosEdit');

			?>
			<script type="text/javascript">
				alert("<?php echo "Please fill the required informations. / Veuillez remplir les informations requises."; ?>");
			</script>
			<?php
					
			break;
		}

		// Verify email
		if(!filter_var($_SESSION['User.Email'], FILTER_VALIDATE_EMAIL))
		{
			ShowCart($TempTongue, true, 'TTemplateCartPageCustomerInfosEdit');

			?>
			<script type="text/javascript">
				alert("<?php echo "The eMail address seems incorrect. / L'adresse couriel semble incorrecte."; ?>");
			</script>
			<?php
					
			break;
		}		

		
		// Verify Location
		if ($_SESSION['ShippingLocation'] == 0)
		{
			ShowCart($TempTongue, true, 'TTemplateCartPageCustomerInfosEdit');
			
			?>
			<script type="text/javascript">
				var answer = confirm("You have selected in-store pickup, click on OK to pickup the order or CANCEL to select a destination.\n\n Vous avez choisi de prendre la commande en magasin, cliquez sur OK pour confirmer ou CANCEL pour choisir une destination.")
				if (answer)
				{
					window.location = "cart.php?Action=ModifyData&ConfirmedLocation=1";
				}
				else
				{
				}
			</script>
			<?php
					
			break;					
		}
	
}
		
		ShowCart($TempTongue, true, 'TTemplateCartPageReviewBeforeConfirm', true);
		//ShowCart($TempTongue);

		if ($TempCodeMessage <> '')
		{
			?>
			<script type="text/javascript">
				alert("<?php echo $TempCodeMessage; ?>");
			</script>
			<?php
		}

		break;
		
	
	case 'ModifyLocation':
		if (array_key_exists('oLocation', $_POST))
			{
			ModifyShippingLocation(substr($_POST['oLocation'],1));
			}
		ShowCart($TempTongue);
		break;
	
	case 'ModifyUserInfos':
		$_SESSION['User.Name'] = $_POST['tName'];
		$_SESSION['User.Phone'] = $_POST['tPhone'];
		$_SESSION['User.Email'] = filter_var($_POST['tEmail'], FILTER_SANITIZE_EMAIL);
		$_SESSION['User.Notes'] = $_POST['tNotes'];
		
		
		ShowCart($TempTongue);
		break;

	case 'ValidateCouponCode':
		$TempCode = strtoupper($_POST['tCouponCode']);
		
		$TempData = LoadFileData('Data/Coupons.php',0,filesize('Data/Coupons.php')-1);
		$TempData = DBDecodeCouponsData($TempData);
		
		// Validate code
		$TempPassed = false;
		
		for ($x = 0; $x < count($TempData); $x++)
		{
			if ($TempData[$x]['Code'] == $TempCode)
			{
				$TempPassed = true;
			}
		}
		
		if ($TempPassed)
		{
			$_SESSION['User.CouponCode'] = $TempCode;
		}
		else
		{
			$_SESSION['User.CouponCode'] = '';		
			echo "<script>alert('Code not found / Code non trouv')</script>";
		}
		
		ShowCart($TempTongue);
		break;
		
	case 'Confirmed':
		if ($_SESSION['User.Email'] <> '')
		{
			if (GetCartItemsTotal() > 0)
			{
				$TempCartHtml = ShowCart($TempTongue, false);
				$TempCartHtml = str_replace('<head>', '<head><base href="http://'.$_SESSION['Settings']['BaseAddress'].'">', $TempCartHtml);
				SendHtmlEmail($_SESSION['Settings']['OrdersEmail'], $_SESSION['Order.No'], $TempCartHtml);
				SendHtmlEmail($_SESSION['User.Email'], $_SESSION['Order.No'], $TempCartHtml);
		
				$TempConfirmed = LoadFile('Templates/TTemplateConfirmedOrderPagePaymentLink'.$TempTongue.'.txt');
				$TempConfirmed = str_replace('[Order.No]', $_SESSION['Order.No'], $TempConfirmed);
				$TempConfirmed = str_replace('[Order.Total]', $_SESSION['Order.Total'], $TempConfirmed);
				echo $TempConfirmed;

				// Update sold items for the next cart orders
				$TempArray = array();
				
				$TempProducts = array();
				
				for ($t = 0; $t < count($_SESSION['Products']); $t++)
				{
					$TempProductID = $_SESSION['Products'][$t]['ID'];
					$TempProduct = DBGetProductData($TempProductID, $TempTongue);
					$TempProducts[] = $TempProduct;
				}
			
				$fh = LockFile('TempFiles/SoldItems.txt');
				if ($fh <> '')
				{
					$TempArray = array();
					$TempArray = LoadOpenedFileIntoArray($fh);

					$TempArray[] = '[OrderNo]';
					$TempArray[] = $_SESSION['Order.No'];

					if (array_key_exists('Member', $_SESSION))
					{
					$TempArray[] = '[MemberID]';
					$TempArray[] = $_SESSION['Member']['Name'];
					}				
					
					$TempArray[] = '[GMTDate]';
					$TempArray[] = gmdate('Y-m-d H:i:s');

					$TempArray[] = '[Language]';
					$TempArray[] = $TempTongue;

					if (array_key_exists('ShippingLocation', $_SESSION))
					{
					if ($_SESSION['ShippingLocation'] > 0)
						{
							$TempShippingData = DBGetShippingData($TempTongue);
							$TempLocations = $TempShippingData['Locations'];

							$TempArray[] = '[ShippingLocation]';
							$TempArray[] = $TempLocations[($_SESSION['ShippingLocation']-1)]['Name'];

							$TempCurrentLocation = $TempLocations[($_SESSION['ShippingLocation']-1)];
							$TempShippingAmount = 0;
							$TempShippingRate = GetShippingRate($TempCurrentLocation, $TempShippingData);
							$TempShippingAmount = $TempShippingRate['Price'] + $TempShippingRate['HandlingFee'];

							$TempArray[] = '[ShippingAmount]';
							$TempArray[] = $TempShippingAmount;

							}
					}
					
					$TempArray[] = '[Name]';
					$TempArray[] = $_SESSION['User.Name'];
					
					$TempArray[] = '[eMail]';
					$TempArray[] = $_SESSION['User.Email'];

					$TempArray[] = '[Phone]';
					$TempArray[] = $_SESSION['User.Phone'];

					$TempArray[] = '[Notes]';
					$TempArray[] = str_replace(array("\r\n", "\n", "\r"), "[LF]", $_SESSION['User.Notes']);
					
					//$_SESSION['User.CouponCode']
					if (array_key_exists('User.CouponCode', $_SESSION))
					{
						$TempArray[] = '[Coupon]';
						$TempArray[] = $_SESSION['User.CouponCode'];
					}

								
					for ($t = 0; $t < count($_SESSION['Products']); $t++)
					{
						$TempArray[] = '[ID]';
						$TempArray[] = $_SESSION['Products'][$t]['ID'];
						
						// Sold quantities
						$TempQuantities = '';
						
						for ($g = 0; $g < count($_SESSION['Products'][$t]['Quantities']); $g++)
						{
							$TempQuantities = $TempQuantities.$_SESSION['Products'][$t]['Quantities'][$g].",";
						}
						
						$TempQuantities = substr($TempQuantities, 0, strlen($TempQuantities)-1);
						
						$TempArray[] = '[Quantities]';
						$TempArray[] = $TempQuantities;

						// Bundle quantities for identification
						// to make sure that the correct bundles correspond to the correct quantities
						
						//for ($h = 0;$h < count($TempProducts); $h++)
						//{
						$TempQuantities = '1,';
							
						for ($g = 0; $g < count($TempProducts[$t]['Bundles']); $g++)
						{
							$TempQuantities = $TempQuantities.$TempProducts[$t]['Bundles'][$g]['Quantity'].",";
						}
							
						$TempQuantities = substr($TempQuantities, 0, strlen($TempQuantities)-1);

						$TempArray[] = '[BundleQuantities]';
						$TempArray[] = $TempQuantities;

						$TempPrices = DBGetFinalPrice($TempProducts[$t]['Price']).',';
							
						for ($g = 0; $g < count($TempProducts[$t]['Bundles']); $g++)
						{
							// DBGetFinalPrice($TempBundle['Price'])
							$TempPrices = $TempPrices.DBGetFinalPrice($TempProducts[$t]['Bundles'][$g]['Price']).","; 
						}
												
						$TempPrices = substr($TempPrices, 0, strlen($TempPrices)-1);
						
						$TempArray[] = '[Prices]';
						$TempArray[] = $TempPrices;						
						
						//}
						
					$TempArray[] = '[EndProduct]';

					}

					$TempArray[] = '[EndOrder]';
					
					SaveArrayToOpenedFile($fh, $TempArray);
					UnlockFile($fh);
				}
				else
				{
					echo 'Lock failed in Confirmed.<br>';
				}
				// Update End
		
				ResetCart();
			}
			else
			{
			echo "Cart is empty.";
			}
		}
		else
		{
			echo 'Error, no email found.';
		}
		break;
		
	case 'RequestShipping':
		if ($_SESSION['User.Email'] <> '')
		{
		$TempCartHtml = ShowCart($TempTongue, false);
		$TempCartHtml = str_replace('<head>', '<head><base href="http://'.$_SESSION['Settings']['BaseAddress'].'">', $TempCartHtml);
		SendHtmlEmail($_SESSION['Settings']['OrdersEmail'], $_SESSION['Order.No'], $TempCartHtml);
		SendHtmlEmail($_SESSION['User.Email'], $_SESSION['Order.No'], $TempCartHtml);
		
		$TempConfirmed = LoadFile('Templates/TTemplateConfirmedOrderPageShippingNotFound'.$TempTongue.'.txt');
		echo $TempConfirmed;
		}
		else
		{
		echo "No email provided.";
		}
		ResetCart();
		break;

	case 'Reset':
		//ResetCart($TempTongue);
		$_SESSION['Products'] = array();
		ShowCart($TempTongue);
		break;
		
	default:
		ShowCart($TempTongue);
		break;
		
	}
}
	
	function ShowDebugData($TempProduct)
	{

			echo "Action: ".$_GET['Action']."<br><br>";
			
			echo "Name: ".$TempProduct['Name']."<br>";
			echo "Description: ".$TempProduct['Description']."<br>";
			echo "DateCreated: ".date("Y-m-d",$TempProduct['DateCreated'])."<br>";

			echo "ReleaseDate: ".date("Y-m-d",$TempProduct['ReleaseDate'])."<br>";
			echo "SpecialOrderDelayWeeks: ".$TempProduct['SpecialOrderDelayWeeks']."<br>";

			echo "Status:".DBGetProductStatus($TempProduct)."<br>";
			
			echo "<br>";
	}


?>